﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Documents;
using System.Windows.Media;
using System.Windows.Controls;
using System.Windows;
using System.Windows.Data;
using System.ComponentModel;
using System.Globalization;
using NanQi.Common;
using System.Diagnostics;

namespace NanQi.Controls
{
    public class PlaceholderAdorner1 : Adorner
    {
        string _placeholder;

        public PlaceholderAdorner1(UIElement ele, string placeholder)
            : base(ele)
        {
            _placeholder = placeholder;

            //var dpd = DependencyPropertyDescriptor.FromProperty(UIElement.VisibilityProperty, typeof(UIElement));
            //dpd.AddValueChanged(ele, new EventHandler((s1, e1) =>
            //{
            //    this.InvalidateVisual();
            //}));
        }
      
        protected override void OnRender(DrawingContext drawingContext)
        {
            TextBox txt = this.AdornedElement as TextBox;
            if (txt == null || !txt.IsVisible || string.IsNullOrEmpty(_placeholder)) return;

            this.IsHitTestVisible = false;

            drawingContext.DrawText(
                new FormattedText
                (
                    _placeholder, 
                    CultureInfo.CurrentCulture,
                    txt.FlowDirection,
                    new Typeface(txt.FontFamily, FontStyles.Italic, txt.FontWeight, txt.FontStretch), 
                    txt.FontSize,
                    Brushes.Gray
                ),
                new Point(4, 2));
        }
    }
}
