﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Documents;
using System.ComponentModel;

namespace NanQi.Controls
{
    public class TextBoxHelper
    {
        #region Placeholder1
        public static string GetPlaceholder1(DependencyObject obj)
        {
            return (string)obj.GetValue(Placeholder1Property);
        }

        public static void SetPlaceholder1(DependencyObject obj, string value)
        {
            obj.SetValue(Placeholder1Property, value);
        }

        public static readonly DependencyProperty Placeholder1Property =
            DependencyProperty.RegisterAttached("Placeholder1", typeof(string), typeof(TextBoxHelper),
                new UIPropertyMetadata(string.Empty, new PropertyChangedCallback(OnPlaceholder1Changed)));

        public static void OnPlaceholder1Changed(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            TextBox txt = d as TextBox;
            if (txt == null || e.NewValue.ToString().Trim().Length == 0) return;

            if (DesignerProperties.GetIsInDesignMode(txt))
            {
                txt.Text = e.NewValue.ToString();
                txt.FontStyle = FontStyles.Italic;
                txt.Foreground = Brushes.Gray;
            }

            RoutedEventHandler loadHandler = null;
            loadHandler = (s1, e1) =>
            {
                txt.Loaded -= loadHandler;

                if (txt.Text.Length == 0)
                {
                    txt.Text = e.NewValue.ToString();
                    txt.FontStyle = FontStyles.Italic;
                    txt.Foreground = Brushes.Gray;
                }
            };

            txt.Loaded += loadHandler;

            txt.GotFocus += (s1, e1) =>
            {
                if (txt.Text == e.NewValue.ToString()
                 && txt.FontStyle == FontStyles.Italic
                 && txt.Foreground == Brushes.Gray)
                {
                    txt.Clear();
                    txt.FontStyle = FontStyles.Normal;
                    txt.Foreground = SystemColors.WindowTextBrush;
                }
            };

            txt.LostFocus += (s1, e1) =>
            {
                if (txt.Text.Length == 0)
                {
                    txt.Text = e.NewValue.ToString();
                    txt.FontStyle = FontStyles.Italic;
                    txt.Foreground = Brushes.Gray;
                }
            };
        }
        #endregion

        #region Placeholder2

        public static string GetPlaceholder2(DependencyObject obj)
        {
            return (string)obj.GetValue(Placeholder2Property);
        }

        public static void SetPlaceholder2(DependencyObject obj, string value)
        {
            obj.SetValue(Placeholder2Property, value);
        }

        public static readonly DependencyProperty Placeholder2Property =
            DependencyProperty.RegisterAttached("Placeholder2", typeof(string), typeof(TextBoxHelper), 
                new UIPropertyMetadata(string.Empty, new PropertyChangedCallback(OnPlaceholder2Changed)));

        public static void OnPlaceholder2Changed(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            TextBox txt = d as TextBox;
            if (txt == null || e.NewValue.ToString().Trim().Length == 0) return;

            RoutedEventHandler loadHandler = null;
            loadHandler = (s1, e1) =>
            {
                txt.Loaded -= loadHandler;

                var lay = AdornerLayer.GetAdornerLayer(txt);
                if (lay == null) return;

                Adorner[] ar = lay.GetAdorners(txt);
                if (ar != null)
                {
                    for (int i = 0; i < ar.Length; i++)
                    {
                        if (ar[i] is PlaceholderAdorner1)
                        {
                            lay.Remove(ar[i]);
                        }
                    }
                }

                if (txt.Text.Length == 0)
                    lay.Add(new PlaceholderAdorner1(txt, e.NewValue.ToString()));

            };
            txt.Loaded += loadHandler;
            txt.TextChanged += (s1, e1) =>
            {
                bool isShow = txt.Text.Length == 0;

                var lay = AdornerLayer.GetAdornerLayer(txt);
                if (lay == null) return;

                if (isShow)
                {
                    lay.Add(new PlaceholderAdorner1(txt, e.NewValue.ToString()));
                }
                else
                {
                    Adorner[] ar = lay.GetAdorners(txt);
                    if (ar != null)
                    {
                        for (int i = 0; i < ar.Length; i++)
                        {
                            if (ar[i] is PlaceholderAdorner1)
                            {
                                lay.Remove(ar[i]);
                            }
                        }
                    }
                }
            };


            //var dpd = DependencyPropertyDescriptor.FromProperty(UIElement.VisibilityProperty, typeof(UIElement));
            //dpd.AddValueChanged(txt, new EventHandler((s1, e1) =>
            //{
            //    bool isShow = txt.Text.Length == 0 && txt.Visibility == Visibility.Visible;

            //    var lay = AdornerLayer.GetAdornerLayer(txt);
            //    if (lay == null) return;

            //    if (isShow)
            //    {
            //        lay.Add(new PlaceholderAdorner1(txt, e.NewValue.ToString()));
            //    }
            //    else
            //    {
            //        Adorner[] ar = lay.GetAdorners(txt);
            //        if (ar != null)
            //        {
            //            for (int i = 0; i < ar.Length; i++)
            //            {
            //                if (ar[i] is PlaceholderAdorner1)
            //                {
            //                    lay.Remove(ar[i]);
            //                }
            //            }
            //        }
            //    }
            //}));
        }



        #endregion

        #region Placeholder2

        public static string GetPlaceholder3(DependencyObject obj)
        {
            return (string)obj.GetValue(Placeholder3Property);
        }

        public static void SetPlaceholder3(DependencyObject obj, string value)
        {
            obj.SetValue(Placeholder3Property, value);
        }

        public static readonly DependencyProperty Placeholder3Property =
            DependencyProperty.RegisterAttached("Placeholder3", typeof(string), typeof(TextBoxHelper),
                new UIPropertyMetadata(string.Empty, new PropertyChangedCallback(OnPlaceholder3Changed)));

        public static void OnPlaceholder3Changed(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            TextBox txt = d as TextBox;
            if (txt == null || e.NewValue.ToString().Trim().Length == 0) return;

            RoutedEventHandler loadHandler = null;
            loadHandler = (s1, e1) =>
            {
                txt.Loaded -= loadHandler;

                var lay = AdornerLayer.GetAdornerLayer(txt);
                if (lay == null) return;

                Adorner[] ar = lay.GetAdorners(txt);
                if (ar != null)
                {
                    for (int i = 0; i < ar.Length; i++)
                    {
                        if (ar[i] is PlaceholderAdorner2)
                        {
                            lay.Remove(ar[i]);
                        }
                    }
                }

                if (txt.Text.Length == 0)
                    lay.Add(new PlaceholderAdorner2(txt, e.NewValue.ToString()));

            };
            txt.Loaded += loadHandler;
            txt.TextChanged += (s1, e1) =>
            {
                bool isShow = txt.Text.Length == 0;

                var lay = AdornerLayer.GetAdornerLayer(txt);
                if (lay == null) return;

                if (isShow)
                {
                    lay.Add(new PlaceholderAdorner2(txt, e.NewValue.ToString()));
                }
                else
                {
                    Adorner[] ar = lay.GetAdorners(txt);
                    if (ar != null)
                    {
                        for (int i = 0; i < ar.Length; i++)
                        {
                            if (ar[i] is PlaceholderAdorner2)
                            {
                                lay.Remove(ar[i]);
                            }
                        }
                    }
                }
            };
        }

        #endregion
    }
}
